

// Radar
// demo:
//   % operator
//   dist( )
//   map( )
//   constrain( )
//   Minum

final int MAX_RADAR_DIAM = 100;



boolean lepFound;

int range, diam;

//leprechaun locations
float l1x, l1y, l2x, l2y;
float ldx, ldy;
float radarX, radarY;

float batteryCharge;

int lepDistance1, lepDistance2; 

color radarCol, bgCol, lepCol, textCol;

void setup( )
{
  size( 600, 600 );
  l1x = 234;
  l1y = 467;
  l2x = 532;
  l2y = 214;
  ldx = .2;
  ldy = .3;
  
  radarCol = color(29, 229, 0 );
  bgCol = color( 0, 10 );
  lepCol = color( 252, 265, 3 );
  textCol = color( 255, 255, 0 );
  
  batteryCharge = 100;
  diam = 10000; 
 
  cursor(CROSS  );
  textAlign( CENTER );
  
  lepFound = false;
}

void draw( )
{
   prepareWindow( ); 
   moveLeps( );
   radar( );
   showData( );
   showBattery( );
}

void radar( )
{
  if ( mousePressed )
  {
    diam = 0;
    radarX = mouseX;
    radarY = mouseY;
  }
  
  if (diam < MAX_RADAR_DIAM && batteryCharge > 0)
  {
      stroke( radarCol );
      noFill( );
      batteryCharge-= .1;
      diam++;

      ellipse( radarX, radarY, diam, diam );
      lepDistance1 = int( dist( radarX, radarY, l1x, l1y ) );
      lepDistance2 = int( dist( radarX, radarY, l2x, l2y ) );
      println( lepDistance1 + "  " + lepDistance2);
      if ( lepDistance1 == diam/2 )
      {
         lepFound = true;
         fill( lepCol );
         ellipse( l1x, l1y, 8, 8 ); 
           // if lepFound realizes it has been located, it relocates
         int relocate = int( random( 100 ) );
         if ( relocate < 5 )
         {
           l1x = int(random(width) );
           l1y = int(random(height) );
         }
      }
      else if ( lepDistance2 == diam/2 )
      {
         lepFound = true;
         fill( lepCol );
         ellipse( l2x, l2y, 8, 8 ); 
         int relocate = int( random( 100 ) );
         if ( relocate < 5 )
         {
           l2x = int(random(width) );
           l2y = int(random(height) );
         }
      }
  }
  
}

void showBattery( )
{
  int batteryRed   = int(constrain(map( batteryCharge, 100, 0, 0, 255 ), 0, 255 ) );
  int batteryGreen = int(constrain(map( batteryCharge, 0, 100, 0, 255 ), 0, 255 ) );
  noFill( );
  stroke( 255 );
  rect(width-150, height-50, 100, 20 );
  noStroke( );
  fill( batteryRed, batteryGreen, 0 );
  rect( width-150, height-50, batteryCharge, 20 );
}

void showData( )
{
   fill( textCol );
   textSize( 14 );
   if ( lepFound )
   {
      text("Leprechaun in grid\n[" + (mouseX/100) + ", " + (mouseY/100) + "]",
            150, height*.95 );
   }
   else
   {
      text("Leprechaun in grid\n[      ]",
            150, height*.95 );     
   }
}

void moveLeps( )
{
  l1x+= ldx;
  if ( l1x > width )
  {
    l1x = random( 50, width-50);
  } 
  l1y += ldy;
  if( l1y > height )
  {
     l1y = random( 50, height-50 );
  } 
  
  l2x+= ldx;
  if ( l2x > width )
  {
    l2x = random( 50, width-50);
  } 
  l2y += ldy;
  if( l2y > height )
  {
     l2y = random( 50, height-50 );
  }  
}

void drawLeps( )
{
   stroke( 255 );
   strokeWeight( 5 );
   point( l1x, l1y);
   point( l2x, l2y );
}

void keyPressed( )
{
   drawLeps( ); 
}

void prepareWindow( )
{
   strokeWeight( 1 );
   fill( bgCol );
   rect( 0, 0, width, height );
   textSize( 14 );
   fill( textCol );
   stroke( 255 );
   int pos = 0;
   while ( pos < width )
   {
      line( 0, pos, width, pos );
      line( pos, 0, pos, height );
      text( pos/100, 15, pos+50 );
      text( pos/100, pos+50, 15 );
      pos += 100 ; 
   }

   fill( textCol );
   textSize( 28 );
   text( "Leprechaun Finder", width/2, 50  );
   
}
